#ifndef _ACTION_H
#define _ACTION_H

#include <pthread.h>
#include <client_handler.h>
#include "object.h"

class Druid;

class Background {
    static const int max_count = 3;
    Druid& act;
    double displace;
    double last;
    double period;
    double maximal;
    double same;
    double value;
    unsigned int errcount;
    double non_poiss;
    std::vector<double> backgrounds;
public:
    Background( Config&, Druid& );
    bool run();
    bool no_needed();
    bool needed();
    std::vector<double>& get() { return backgrounds; }
private:
    std::vector<double> measure();
};

class Druid {
    static const int max_attempts = 8;
    static const int max_retries = 2;
    std::auto_ptr<ClientHandler> dimm;
    std::auto_ptr<ClientHandler> mass;
    std::auto_ptr<ClientHandler> tlsp;
    Background background;
    ObjectInfo star;
    unsigned int settle_time;
    unsigned int errcount;
    double focus;
    double separation;
    double sep_tolrn;
    double work_zone;
    double mass_mag_ext;
    unsigned int errflux;
    std::vector<double> chan_fluxes;
    std::vector<double> star_fluxes;
    std::vector<double> mass_mag_set;
    friend class Background;
    bool mass_enable;
    bool cnt_on;
    double guide_last;
public:
    Druid( Config& );
    ~Druid();
    bool point_star( const ObjectInfo& );
    bool check_star( const ObjectInfo& );
    bool check_status();
    bool check_experiment_status( unsigned int );
    bool check_background();
    bool measurement();
    bool dimm_measurement();
    bool beginning();
    bool photo_stability( unsigned int );
    bool cnt( bool );
    void regime( const std::string& );
private:
    bool check_flux();
    bool center_star();
    bool init();
    bool park( ClientHandler* );
    void focusing( double );
    bool focus_dimm();
    double check_separation();
    bool stop_guiding();
    bool start_guiding();
    bool start_dimm_guiding();
    bool check_mass_mag();
    bool check_aperture_ratio(); 
    void camera( const std::string& );
};

#endif
