#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <iostream>
#include <iomanip>
#include <sys/stat.h>
#include <sys/types.h>

#include <server.h>
#include <errlog.h>
#include "defnames.h"
#include "sub_main.h"


int main(int ac, char **av ) {
    std::cerr << "\n\t\t" << progname << VERSION << std::endl;
    if( Visor::cmd_line( ac, av ) ) return 1;
    Visor::create();
    try {
        while( !Visor::isQuit() ){
            try {
                SocketWatcher::instance().doPoll(2);
            }
            catch (const std::exception& e ) {
                ErrlogSingl::instance().write( std::string("Main loop: ") + e.what() );
                sleep(1);
            }
            catch (...) {
                ErrlogSingl::instance().write( "Main loop: Unknown type exception" );
                sleep(1);
            }
        }
    }
    catch (const std::exception& e ) {
        ErrlogSingl::instance().write( std::string("Main: ") + e.what() );
    }
    std::cerr << "\n\t\t" << progname << VERSION << " finished" << std::endl;
    return 0;
}
