#ifndef _PROCESS_H
#define _PROCESS_H

#include <errlog.h>
#include <configs.h>

#include "omicron.h"
#include "actions.h"
#include "object.h"

struct SV_CMD {
    std::string cfgfile;
    bool test_mode;
    bool man_mode;
    double final_time;
};

class Observation {
    static const int max_count = 3;
    static const int max_point = 4;
    Config acfg;
    Omicron Asm;
    Object objm;
    std::auto_ptr<Druid> massdimm;
    std::vector<ObjectInfo> photometric_list;
    ObjectInfo target;
    int HR;
    int HRE;
    int point_counter;
    int check_counter;
    int cycle_counter;
    unsigned int serie;
    unsigned int exp_serie;
    bool stability;
    int measurement_number;
public:
    static SV_CMD cmd;
    static bool terminate;
    Observation();
    ~Observation(){} // std::cerr << "Observation destructor" << std::endl; }
    void programm();
    void experiment();
private:
    bool pointing( const ObjectInfo& );
    void photometry( const std::vector<ObjectInfo>& );
};

#endif
